{% extends 'index.html' %}

{% block head %}
<script src="https://cdn.jsdelivr.net/npm/chart.js"></script>

<link rel="stylesheet" href="{{url_for('static', filename='css/user-dashboard.css')}}">
<link rel="stylesheet" href="{{url_for('static', filename='css/user-dashboard-responsive.css')}}">
<link rel="stylesheet" href="{{url_for('static', filename='css/stats.css')}}">
<link rel="stylesheet" href="{{url_for('static', filename='css/stats-responsive.css')}}">
<title>Tableau de bord</title>
{% endblock %}

{% block main %}

<h1 class="greet">Bonjour {{usrFirstname}},</h1>

<div class="bookings-table">

    <div class="title">
        <label>Vos réservations</label>

        <div>
            <button id="add-booking-btn">Ajouter</button>
            <span class="warn" id="no-plates">Aucune plaque enregistrée.<br>Vous pouvez en enregistrer une dans votre
                espace compte</span>

            <span class="warn" id="not-confirmed">Votre profil n'a pas été confirmé par un administrateur.<br>Un
                administrateur doit confirmer votre profil pour que vous puissiez effectuer des réservations.</span>
        </div>
    </div>

    <div class="header">

        <label>Immatriculation</label>
        <label>Criticité</label>
        <label>Horaire de début</label>
        <label>Horaire de fin</label>
        <label>Durée</label>

    </div>

    <div class="body">

        {% if bookings |length > 0 %}
        {% for book in bookings %}
        <div class="entry" id="{{book['id']}}">
            <label class="cell immat">{{ book["immat"] }}</label>
            <label class="cell criticity">{{ book["criticity"] }}</label>
            <label class="cell start">{{ book["book_start"] }}</label>
            <label class="cell end">{{ book["book_end"] }}</label>
            <label class="cell duration">{{ book["duration"] }}</label>
            <a class="booking-action edit">
                <svg stroke="green" fill="none" viewBox="-2 -9 120 120">
                    <path stroke-width="5" stroke-linejoin="round"
                        d="m 80 10 l -50 60 l -10 20 l 20 -10 l 50 -60 a 1 1 0 0 0 -10 -10"></path>
                </svg>
            </a>
            <a class="booking-action delete">
                <svg stroke="red" fill="none" viewBox="3 3 100 100">
                    <path stroke-width="5" stroke-linejoin="round"
                        d="m 30 30 l 0 60 l 40 0 l 0 -60 m 5 5 a 1 1 0 0 0 0 -10 l -50 0 a 1 1 0 0 0 0 10 m 20 -10 a 1 1 0 0 1 0 -5 l 10 0 a 1 1 0 0 1 0 5">
                    </path>
                </svg>
            </a>
        </div>
        {% endfor %}
        {% else %}
        <label>Vous n'avez aucune réservation à venir</label>
        {% endif %}

    </div>

</div>

<h1 class="greet" id="stats-headline">Statistiques du parking</h1>

<div class="stats-container">
    <div class="chart-container" id="fill-rate-container">
        <h2 id="fill-rate-headline">Taux de remplissage du parking</h2>

        <div class="chart-period-selector">
            <input class="fill-rate-radio" type="radio" name="fill-rate-unit" id="fill-rate-hourly" value="hourly"
                checked>
            <label for="fill-rate-hourly">Horaire</label>

            <input class="fill-rate-radio" type="radio" name="fill-rate-unit" id="fill-rate-daily" value="daily">
            <label for="fill-rate-daily">Journalier</label>

            <input class="fill-rate-radio" type="radio" name="fill-rate-unit" id="fill-rate-weekly" value="weekly">
            <label for="fill-rate-weekly">Hebdomadaire</label>

            <input class="fill-rate-radio" type="radio" name="fill-rate-unit" id="fill-rate-monthly" value="monthly">
            <label for="fill-rate-monthly">Mensuel</label>
        </div>


        <canvas class="chart" id="fill-rate-chart"></canvas>

        <form class="date-selector" id="fill-rate-change-period">
            <label for="fill-rate-start-date">Du</label>
            <input class="chart-date" type="text" name="fill-rate-start-date" id="fill-rate-start-date" required>
            <input class="chart-time" type="text" name="fill-rate-start-time" id="fill-rate-start-time" value="00:00"
                required>

            <label for="fill-rate-end-date">Jusqu'au</label>
            <input class="chart-date" type="text" name="fill-rate-start-end-date" id="fill-rate-end-date" required>
            <input class="chart-time" type="text" name="fill-rate-start-end-time" id="fill-rate-end-time" value="00:00"
                required>

            <button type="submit">Mettre à jour</button>
        </form>
    </div>

    <div class="chart-container" id="real-fill-rate-container">
        <h2 id="real-fill-rate-headline">Taux de remplissage réel</h2>

        <div class="chart-period-selector">
            <input class="real-fill-rate-radio" type="radio" name="real-fill-rate-unit" id="real-fill-rate-hourly" value="hourly"
                checked>
            <label for="real-fill-rate-hourly">Horaire</label>

            <input class="real-fill-rate-radio" type="radio" name="real-fill-rate-unit" id="real-fill-rate-daily" value="daily">
            <label for="real-fill-rate-daily">Journalier</label>

            <input class="real-fill-rate-radio" type="radio" name="real-fill-rate-unit" id="real-fill-rate-weekly" value="weekly">
            <label for="real-fill-rate-weekly">Hebdomadaire</label>

            <input class="real-fill-rate-radio" type="radio" name="real-fill-rate-unit" id="real-fill-rate-monthly" value="monthly">
            <label for="real-fill-rate-monthly">Mensuel</label>
        </div>

        <canvas class="chart" id="real-fill-rate-chart"></canvas>
        
        <form class="date-selector" id="real-fill-rate-change-period">
            <label for="real-fill-rate-start-date">Du</label>
            <input class="chart-date" type="text" name="real-fill-rate-start-date" id="real-fill-rate-start-date" required>
            <input class="chart-time" type="text" name="real-fill-rate-start-time" id="real-fill-rate-start-time" value="00:00"
                required>

            <label for="real-fill-rate-end-date">Jusqu'au</label>
            <input class="chart-date" type="text" name="real-fill-rate-start-end-date" id="real-fill-rate-end-date" required>
            <input class="chart-time" type="text" name="real-fill-rate-start-end-time" id="real-fill-rate-end-time" value="00:00"
                required>

            <button type="submit">Mettre à jour</button>
        </form>
    </div>

    <div class="chart-container" id="park-usage-container">
        <h2 id="park-usage-headline">Taux d'utilisation du parking</h2>
        <canvas class="chart" id="park-usage-chart"></canvas>
    </div>

    <div class="chart-container" id="park-duration">
        <h2 id="park-duration-headline">Durée de stationnement</h2>

        <div class="wrapper">
            <form action="{{url_for('get_parkduration_plate')}}" id="park-duration-by-plate">
                <label for="plate-duration">Par plaque:</label>
                <input type="text" name="plate-duration" id="plate-duration-input" placeholder="AA-123-AA">
    
                <button type="submit">Recherche par plaque</button>
            </form>
            
            <form id="park-duration-by-entity" action="{{url_for('get_parkduration_entity')}}">
                <label for="entity-duration">Par établissement:</label>
                <select name="entity-duration" id="entity-duration-selector">
                    {% for e in entities %}
                    <option value="{{e[0]}}">{{e[1]}}</option>
                    {% endfor %}
                </select>
    
                <button type="submit">Recherche par établissement</button>
            </form>

            <p class="search-result hidden" id="park-duration-result"></p>
        </div>
    </div>
</div>

<dialog class="add-booking-popup" id="add-booking-dialog">
    <div class="headline">
        <h1 class="add-booking-headline">Ajouter une réservation</h1>

        <button class="close" id="close-add-booking-dialog" value="cancel"><img
                src="{{url_for('static', filename='assets/close.png')}}" alt="Close"></button>
    </div>

    <form class="book" id="add-booking" action="{{url_for('add_booking')}}" method="dialog">

        <div class="row" id="infos">
            <div class="cell">
                <label id="plate">Votre véhicule</label>
                <select name="plate" id="plate-selector" required></select>
            </div>

            <div class="cell">
                <label class="repeat">Périodicité</label>
                <select name="interval" id="period-selector">
                    <option value="unique">Pas de répétition</option>
                    <option value="daily">Quotidienne</option>
                    <option value="weekly">Hebdomadaire</option>
                    <option value="monthly">Mensuelle</option>

                    <!--<option value="weekday">La semaine (Lundi au Vendredi)</option>-->
                    <option value="custom">Personnalisé...</option>
                </select>
            </div>
        </div>

        <div class="row" id="datetimes">
            <label id="start">Date et durée de la réservation (<span id="duration"></span>)</label>

            <!--<label class="date pick-label" id="date-start-label">-->
                <input class="date pick-label" id="start-date-picker" name="booking-date-start" type="text" readonly required>
            <!--</label>-->


            <label class="time pick-label">
                <input id="time-start-picker" name="booking-time-start" type="text"
                    pattern="([01]?[0-9]|2[0-3]):[0-5][0-9]" required>
            </label>


            <!--<label class="date pick-label" id="date-end-label">-->
                <input class="date pick-label" id="end-date-picker" name="booking-date-end" type="text" readonly required>
            <!--</label>-->

            <label class="time pick-label">
                <input id="time-end-picker" name="booking-time-end" type="text" pattern="([01]?[0-9]|2[0-3]):[0-5][0-9]"
                    required>
            </label>

            <span class="warn" id="weekly-booking-restrict">Vous ne pouvez pas changer la date lors d'une répétition
                personnalisée hebdomadaire</span>
        </div>

        <div class="row" id="end-recurrence">
            <label>Fin de la répétition le </label>

            <!--<label class="date pick-label" id="recurrence-date-end-label">-->
                <input class="date pick-label" id="recurrence-end-date-picker" name="recurrence-booking-date-end" type="text" readonly required>
            <!--</label>-->
        </div>

        <button class="submit-booking-form" id="submit-booking" type="submit" value="submit">Ajouter</button>
    </form>

</dialog>

<dialog class="add-booking-popup" id="add-booking-custom-dialog">

    <div class="headline">
        <h3 class="add-booking-headline">Répétition personnalisé</h3>

        <button class="close" id="close-add-booking-custom-dialog" value="cancel">
            <img src="{{url_for('static', filename='assets/close.png')}}" alt="Close">
        </button>
    </div>

    <form class="book" id="add-booking-custom" method="dialog">

        <label>Se répète tous les </label>

        <div id="custom-recurrence-wrapper">
            <label class="date pick-label" id="custom-recurrence-amount-label">
                <input id="custom-recurrence-picker" name="custom-recurrence-amount" type="number" value="1" min="1"
                    required>
            </label>

            <select name="custom-interval" id="custom-recurrence-interval-selector">
                <option value="day" selected="selected" autocomplete="off">jours</option>
                <option value="week" autocomplete="off">semaines</option>
                <option value="month" autocomplete="off">mois</option>
            </select>
        </div>

        <div id="custom-recurrence-week" style="display:none;">
            <label>Le: </label>

            <div id="days-pins">
                <input type="checkbox" name="monday" id="custom-monday" value="monday">
                <label class="unselectable" for="custom-monday">L</label>
                <input type="checkbox" name="tuesday" id="custom-tuesday" value="tuesday">
                <label class="unselectable" for="custom-tuesday">M</label>
                <input type="checkbox" name="wednesday" id="custom-wednesday" value="wednesday">
                <label class="unselectable" for="custom-wednesday">M</label>
                <input type="checkbox" name="thursday" id="custom-thursday" value="thursday">
                <label class="unselectable" for="custom-thursday">J</label>
                <input type="checkbox" name="friday" id="custom-friday" value="friday">
                <label class="unselectable" for="custom-friday">V</label>
                <input type="checkbox" name="saturday" id="custom-saturday" value="saturday">
                <label class="unselectable" for="custom-saturday">S</label>
                <input type="checkbox" name="sunday" id="custom-sunday" value="sunday">
                <label class="unselectable" for="custom-sunday">D</label>
            </div>
        </div>



        <button class="submit-booking-form" id="submit-booking-custom" type="submit" value="submit">Valider</button>
    </form>
</dialog>

<dialog id="add-booking-failed">
    <form method="dialog">
        <h3>Aucune place disponible pour ce créneau horaire</h3>

        <button type="submit">Ok</button>
    </form>
</dialog>

<dialog class="delete-booking-popup" id="delete-booking-dialog">
    <form id="delete-booking" action="{{url_for('delete_booking')}}" method="dialog">
        <h2>Supprimer votre réservation</h2>

        <label>Etes-vous sûr de vouloir supprimer votre réservation du <span id="delete-booking-date-start"></span> au
            <span id="delete-booking-date-end"></span> ?</label>

        <button id="close-delete-dialog" type="reset" value="cancel">Annuler</button>
        <button id="submit-delete-dialog" type="submit" value="delete">Supprimer</button>

    </form>
</dialog>

{% endblock %}

{% block script %}
<script src="{{url_for('static', filename='js/dashboard.js')}}"></script>
<script src="{{url_for('static', filename='js/stats/stats-general.js')}}"></script>
<script src="{{url_for('static', filename='js/stats/stats-fillrate.js')}}"></script>
<script src="{{url_for('static', filename='js/stats/stats-park-usage.js')}}"></script>
<script src="{{url_for('static', filename='js/stats/stats-realfillrate.js')}}"></script>
<script src="{{url_for('static', filename='js/stats/stats-park-duration.js')}}"></script>
{% endblock %}